

import ddf.minim.*;
import ddf.minim.signals.*;

Minim minim;
AudioOutput out;
SineWave sine;
SawWave saw;
SquareWave square2;
SquareWave square;
int pressed = 0;

void setup()
{
  size(512, 200, P2D);
  
  minim = new Minim(this);
  out = minim.getLineOut(Minim.STEREO);
  sine = new SineWave(440, .5, out.sampleRate());
  sine.noPortamento();
  square = new SquareWave(440, .2, out.sampleRate());
  square2 = new SquareWave(440, .2, out.sampleRate());
  saw = new SawWave(440, .2, out.sampleRate());
  //out.addSignal(sine);
}

void draw()
{
  background(0);

}

void keyPressed()
{
    out = minim.getLineOut(Minim.STEREO);

  if((keyCode == '1')&&(pressed==0))
  {
    pressed = 1;
    float freq = 440;
    sine.setFreq(freq);
    sine.setAmp(.5); 
    square.setAmp(.2);
    saw.setAmp(.1);    
    square.setFreq(freq/2);
    saw.setFreq(freq/4);
    out.addSignal(sine);
    out.addSignal(square);
    out.addSignal(saw);
  }
  if((keyCode == '2')&&(pressed==0))
  {
    pressed = 1;
    float freq = 493.88;
    sine.setFreq(freq);
    sine.setAmp(.5); 
    square.setAmp(.2);
    saw.setAmp(.1);    
    square.setFreq(freq/2);
    saw.setFreq(freq/4);
    out.addSignal(sine);
    out.addSignal(square);
    out.addSignal(saw);
  }
  if((keyCode == '3')&&(pressed==0))
  {
    pressed = 1;
    float freq = 554.37;
    sine.setFreq(freq);
    sine.setAmp(.5); 
    square.setAmp(.2);
    saw.setAmp(.1);    
    square.setFreq(freq/2);
    saw.setFreq(freq/4);
    out.addSignal(sine);
    out.addSignal(square);
    out.addSignal(saw);
  }
  if((keyCode == '4')&&(pressed==0))
  {
    pressed = 1;
    float freq = 587.33;
    sine.setFreq(freq);
    sine.setAmp(.5); 
    square.setAmp(.2);
    saw.setAmp(.1);    
    square.setFreq(freq/2);
    saw.setFreq(freq/4);
    out.addSignal(sine);
    out.addSignal(square);
    out.addSignal(saw);
  }
  if((keyCode == 'Q')&&(pressed==0))
  {
    pressed = 1;
    float freq = 659.26;
    sine.setFreq(freq);
    sine.setAmp(.5); 
    square.setAmp(.2);
    saw.setAmp(.1);    
    square.setFreq(freq/2);
    saw.setFreq(freq/4);
    out.addSignal(sine);
    out.addSignal(square);
    out.addSignal(saw);
  }
  if((keyCode == 'W')&&(pressed==0))
  {
    pressed = 1;
    float freq = 739.99;
    sine.setFreq(freq);
    sine.setAmp(.5); 
    square.setAmp(.2);
    saw.setAmp(.1);    
    square.setFreq(freq/2);
    saw.setFreq(freq/4);
    out.addSignal(sine);
    out.addSignal(square);
    out.addSignal(saw);
  }
  if((keyCode == 'E')&&(pressed==0))
  {
    pressed = 1;
    float freq = 830.61;
    sine.setFreq(freq);
    sine.setAmp(.5); 
    square.setAmp(.2);
    saw.setAmp(.1);    
    square.setFreq(freq/2);
    saw.setFreq(freq/4);
    out.addSignal(sine);
    out.addSignal(square);
    out.addSignal(saw);
  }  
  if((keyCode == 'R')&&(pressed==0))
  {
    pressed = 1;
    float freq = 880.00;
    sine.setFreq(freq);
    sine.setAmp(.5); 
    square.setAmp(.2);
    saw.setAmp(.1);    
    square.setFreq(freq/2);
    saw.setFreq(freq/4);
    out.addSignal(sine);
    out.addSignal(square);
    out.addSignal(saw);
  }  
  
  
  
  if((keyCode == 'A')&&(pressed==0))
  {
    pressed = 1;
    float freq = 110;
    square.setFreq(freq);
    square.setAmp(.5); 
    square2.setAmp(.2);
    saw.setAmp(.1);    
    square2.setFreq(freq/2);
    saw.setFreq(freq/4);
    out.addSignal(square);
    out.addSignal(square2);
    out.addSignal(saw);
  }
  if((keyCode == 'S')&&(pressed==0))
  {
    pressed = 1;
    float freq = 123.47;
    square.setFreq(freq);
    square.setAmp(.5); 
    square2.setAmp(.2);
    saw.setAmp(.1);    
    square2.setFreq(freq/2);
    saw.setFreq(freq/4);
    out.addSignal(square);
    out.addSignal(square2);
    out.addSignal(saw);
  }
  if((keyCode == 'D')&&(pressed==0))
  {
    pressed = 1;
    float freq = 138.59;
    square.setFreq(freq);
    square.setAmp(.5); 
    square2.setAmp(.2);
    saw.setAmp(.1);    
    square2.setFreq(freq/2);
    saw.setFreq(freq/4);
    out.addSignal(square);
    out.addSignal(square2);
    out.addSignal(saw);
  }
  if((keyCode == 'F')&&(pressed==0))
  {
    pressed = 1;
    float freq = 146.83;
    square.setFreq(freq);
    square.setAmp(.5); 
    square2.setAmp(.2);
    saw.setAmp(.1);    
    square2.setFreq(freq/2);
    saw.setFreq(freq/4);
    out.addSignal(square);
    out.addSignal(square2);
    out.addSignal(saw);
  }
  if((keyCode == 'Z')&&(pressed==0))
  {
    pressed = 1;
    float freq = 164.81;
    square.setFreq(freq);
    square.setAmp(.5); 
    square2.setAmp(.2);
    saw.setAmp(.1);    
    square2.setFreq(freq/2);
    saw.setFreq(freq/4);
    out.addSignal(square);
    out.addSignal(square2);
    out.addSignal(saw);
  }
  if((keyCode == 'X')&&(pressed==0))
  {
    pressed = 1;
    float freq = 185.00;
    square.setFreq(freq);
    square.setAmp(.5); 
    square2.setAmp(.2);
    saw.setAmp(.1);    
    square2.setFreq(freq/2);
    saw.setFreq(freq/4);
    out.addSignal(square);
    out.addSignal(square2);
    out.addSignal(saw);
  }
  if((keyCode == 'C')&&(pressed==0))
  {
    pressed = 1;
    float freq = 207.65;
    square.setFreq(freq);
    square.setAmp(.5); 
    square2.setAmp(.2);
    saw.setAmp(.1);    
    square2.setFreq(freq/2);
    saw.setFreq(freq/4);
    out.addSignal(square);
    out.addSignal(square2);
    out.addSignal(saw);
  }  
  if((keyCode == 'V')&&(pressed==0))
  {
    pressed = 1;
    float freq = 220.00;
    square.setFreq(freq);
    square.setAmp(.5); 
    square2.setAmp(.2);
    saw.setAmp(.1);    
    square2.setFreq(freq/2);
    saw.setFreq(freq/4);
    out.addSignal(square);
    out.addSignal(square2);
    out.addSignal(saw);
  }   
  
  
}


void keyReleased()
{
  pressed = 0;
   sine.setAmp(0); 
   square.setAmp(0);
   square2.setAmp(0);
   saw.setAmp(0);
   out.close();
   out.removeSignal(sine);
   out.removeSignal(square);
   out.removeSignal(square2);
   out.removeSignal(saw);
}

  //float pan = map(mouseX, 0, width, -1, 1);
  //sine.setPan(pan);


void stop()
{
  out.close();
  minim.stop();
  
  super.stop();
}
